![imagebanner](https://cdn.discordapp.com/attachments/817828391662649366/1107720578422538341/BO4Alt.png)

### The Black Ops 4 Collection

I want to make mention, thank you Yung, for being the only person I know who was as interested in Black Ops 4 as I was, sharing the commraderie in regards to these guns for a short moment, it was still a great time.

And thank you, Kirloper, for having the definitive collection of assets, all the bells and whistles I need to bring these guns to H3VR.

Thank you to Ssgt Cheese and Angry Noob, for your struggles to implement the Rampart 17 was the flame I needed to bring out my A-game and make these guns myself.

---

### Background

I was there from beginning to end. From debut to its last second year post content release. Black Ops 4 was a roller coaster in itself, full of its own ups and downs.

Majority of my favor went into Blackout. It was my first taste of a battle royale, and it was where I had the majority of my favorite moments with this game. From resource gathering to the wingsuits, there was an unforeseen addiction to follow from my first games onward. The RNG grew to unseen heights with the introduction of more Zombies wonder weapons, and mayhem is the only word that could describe all these changes.

It also should be mentioned, the countless amounts of solo games I had with the zombies mode, never did I consider going into a lobby with three randos, because I soon realized I was better off by myself, and had more fun with the zombies gamemode by myself. With this loner approach I got more familiar with the weapons this game provided, and there was an even closer relationship with gunsmith and operator mods providing the game-changers to the zombies mode, to make it as close to the chaos that Black Ops 1 PaP weapons of the past.

With seasons came further changes and further hype. The Grand Heist expansion delivering hotrods and fast cars was an homage to all the fun times I had with BF Hardline, and [the Apocalypse Z trailer](https://www.youtube.com/watch?v=seFqlqmrRz4), having the most hype trailer I have experienced out of any Call of Duty, puts my love for both of these gamemodes together into one supermode (Pandemic) that turned out to be the highlight of my time playing this game.

Alongside, of course, Alcatraz as a Blackout mode, which turned out to be such a fan favorite the concept of a "Rebirth" gamemode was something that stuck around for both Warzone and Warzone 2.0, but these later iterations did not hold a torch to this first iteration. The power that Alcatraz had, between the Zombies map, the OST, the Easter Egg, and then the compelling and ever so addicting Blackout gamemode, I think it needs its own tribute in itself down the line...

But, I've rambled on, lets snap back to our topic.

---

### BO4 Weapons and H3VR, The History

Can't get anymore grounded-fictional then this. BO4 weapons take the cake in having spinoffs of real life firearms. This was the tipping point for them [to improve their weapon quality compared to previous titles](https://youtu.be/rd_2lwp1rQU?t=765), and set the bar higher for games that followed.

Weapons in Black Ops 4 was a hybrid between accurate portrayal and innovation that had stuck with me for years and years. Even when I don't see eye to eye in their decisions in regards to gameplay, the level of effort they went into making the weapons will always be commendable to me.

One other key thing to note, they loved their guns so much that they wanted to make spin-offs of their own guns with an artistic flair to them. Mastercrafts. This was the birthplace of skins beyond skins, and ultimately where I got my inspirations from with the NEXT series. Mastercrafts get a bad rep for how they are introduced nowadays, [but they were originally supposed to be a grind just like mastery camos!](https://www.vgr.com/call-of-duty-black-ops-4-mastercraft-how-to-get-mastercraft-weapons/)

(Of course, just like the concept of vault weapons for MW '22, this concept was scrapped entirely. They did try for a mix, having it as a purchasable camo, only needing to grind in order to unlock the mastercraft, but that mix just wasn't going to work because people complained they couldn't use the content that they bought...)

It's 2023 now, and these guns and what they did to them are now time capsules of a time where there was still a market for innovation. We have the ability to bring into H3VR through asset availability and the convenience of Meatkit... So whats the difficulty?

---

### BO4 Weapons and H3VR, Their Compatibility

Black Ops 4 isn't fully compatible with Greyhound in the same way BO3 is. You're going to find a lot of textures mislabeled as "Ximages_(insert random string of numbers here)". There are multiple materials for the same set of textures, the metallics somewhat different. For newcomers introduced with this, it turns out to be an extremely daunting task. Not only that, but the model's built in base color data interferes with cross matching materials with Substance Painter.

So from the getgo, you have a model that doesn't play nice with Material Map Channel Packer or Substance Painter. It also has the worse case of improper scaling out of any COD model, with assault rifles needing to be downsized by .88x scale to match their IRL counterparts.

My first take with these assets was with the KAP-45. I wanted to cooperate with implementers, handle this terrible hurdle of ximage nonsense. Split the model myself, make the alloy textures myself, due the heavy lifting!... No takers. Nobody was interested in BO4 weapons like I was. That was the bitter pill I needed to swallow.

Over the course of literal months I have found ways to streamline the process and get these models to cooperate with me. A bulk erasure of base color data, playing along with BO4's dupe material inconvenience. Nerd shit and stuff that I'm sure you are skimming past if you're just here for the juicy stuff.

To be blunt, out of all the models I get to work with, it's a tie between BO4 and BOCW models in terms of difficulty, especially with the introduction of ximages / xmaterials namenclature, but in terms of quality, I believe the results are worth it. 

---

![imagegif](https://cdn.discordapp.com/attachments/817828391662649366/1107520283407044659/BO4Modpack.gif)

### The BO4 Weapon List (* For skin related releases, ** for WIP, unreleased mods)

Submachine Guns -- MX9, GKS, Cordite*, Saug 9mm, Daemon 3XB, 

Assault Rifles -- ICR-7, Rampart-17, VAPR-XRG, Maddox RFB, SWAT RFT, Peacekeeper, Echohawk Dualbore (now known as the Doublecross)

Tac Rifles -- Auger DMR, ABR-223, Swordfish, S6 Stingray

Shotguns -- Mog-12, SG12, Rampage, Argus

Light Machine Guns -- Titan**, Hades, VKM 750**, Tigershark*, Zweihander

Sniper Rifles -- SDM*, Havelina*

Pistols -- Strife, Mozu, RK7 Garrison, Kap 45

Comparing this roster to the source material, over 80% of all the weapons in Black Ops 4 have now been implemented into H3VR. The biggest blemish is the lack of a sniper rifle roster, compared to BO3 where that roster was near complete.

It was rewarding to have been the sole implementer for all of these weapons, especially after discussing the history and hardships behind it. For any lurking BO4 fan, given your own history, I hope you enjoy using these weapons in VR. Be sure to get a good look at them in a way you never did before!

---

### Sources and Credits

The weapons featured in this modpack belong to the game Call of Duty, Black Ops 4, developers being Treyarch and Raven, Activision owning the studios.

The earlier implementations were through Yung's asset support, and the rest were through Kirloper's thicc repo of audio assets.

Credit goes where credit is due, thank you PLOOF for introducing me to Skye's Audio repo, thats where the audio for these BO4 weapons came from.

### Updates

V0.9.9 -- Initial Release, pre-Space Race upload. V1.0.0 will come moments after H3VR's experimental branch goes to the main branch, the delay due to needed scripts required for select Space Race firearms!

V1.0.0 -- The Space Race update is here! Zweihander and Titan to follow soon...